# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free
%define bname fop

Name:           xmlgraphics-fop
Version:        0.95
Release:        6%{?dist}
Epoch:          0
Summary:        XSL-driven print formatter
License:        ASL 2.0
Group:          Text Processing/Markup/XML
# svn export http://svn.apache.org/repos/asf/xmlgraphics/fop/tags/fop-0_95/ fop-0.95
# tar cvzf fop-0.95-src.tar.gz fop-0.95
Source0:        http://www.apache.org/dist/xmlgraphics/fop/fop-0.95-src.tar.gz
Source1:        %{name}.script
Patch0:         xmlgraphics-fop-build.patch
Patch1:         xmlgraphics-fop-cli.patch
URL:            http://xmlgraphics.apache.org/fop/
Requires(post):    jpackage-utils >= 0:1.7.4
Requires(postun):  jpackage-utils >= 0:1.7.4
Requires:       jpackage-utils >= 0:1.7.4
Requires:       java >= 0:1.5.0
Requires:       xmlgraphics-batik
Requires:       excalibur-avalon-logkit
Requires:       excalibur-avalon-framework-api
Requires:       excalibur-avalon-framework-impl
Requires:       xalan-j2
Requires:       xerces-j2
Requires:       xmlgraphics-commons
Requires:       xml-commons-jaxp-1.3-apis
BuildRequires:  jpackage-utils >= 0:1.7.4
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  java-javadoc
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-trax
BuildRequires:  ant-junit
BuildRequires:  junit
BuildRequires:  xmlgraphics-batik
BuildRequires:  xmlgraphics-batik-javadoc
BuildRequires:  excalibur-avalon-logkit
BuildRequires:  excalibur-avalon-framework-api
BuildRequires:  excalibur-avalon-framework-impl
BuildRequires:  servlet_api
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xmlgraphics-commons >= 0:1.2
BuildRequires:  xmlunit
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:       noarch
%endif

%description
FOP is the world's first print formatter driven by XSL formatting
objects. It is a Java application that reads a formatting object tree
and then turns it into a PDF document. The formatting object tree, can
be in the form of an XML document (output by an XSLT engine like XT or
Xalan) or can be passed in memory as a DOM Document or (in the case of
XT) SAX events.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{bname}-%{version}
find -name "*.jar" | xargs -t rm
%patch0 -p0 -b .build
%patch1 -p1 -b .cli

pushd lib
ln -s $(build-classpath excalibur/avalon-framework-api)
ln -s $(build-classpath excalibur/avalon-framework-impl)
ln -s $(build-classpath commons-io)
ln -s $(build-classpath commons-logging)
ln -s $(build-classpath servlet_api)
ln -s $(build-classpath xml-commons-jaxp-1.3-apis)
ln -s $(build-classpath xml-commons-jaxp-1.3-apis-ext)
ln -s $(build-classpath xmlgraphics-batik/anim)
ln -s $(build-classpath xmlgraphics-batik/awt-util)
ln -s $(build-classpath xmlgraphics-batik/bridge)
ln -s $(build-classpath xmlgraphics-batik/css)
ln -s $(build-classpath xmlgraphics-batik/dom)
ln -s $(build-classpath xmlgraphics-batik/ext)
ln -s $(build-classpath xmlgraphics-batik/extension)
ln -s $(build-classpath xmlgraphics-batik/gvt)
ln -s $(build-classpath xmlgraphics-batik/parser)
ln -s $(build-classpath xmlgraphics-batik/svg-dom)
ln -s $(build-classpath xmlgraphics-batik/svggen)
ln -s $(build-classpath xmlgraphics-batik/script)
ln -s $(build-classpath xmlgraphics-batik/transcoder)
ln -s $(build-classpath xmlgraphics-batik/util)
ln -s $(build-classpath xmlgraphics-batik/xml)
ln -s $(build-classpath xalan-j2)
ln -s $(build-classpath xalan-j2-serializer)
ln -s $(build-classpath xerces-j2)
ln -s $(build-classpath xmlgraphics-commons)
ln -s $(build-classpath xmlunit)
popd

%build
export CLASSPATH=
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/{junit,trax}`
%{ant} \
  -Dbatik.javadoc=%{_javadocdir}/xmlgraphics-batik \
  package junit maven-artifacts

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m 644 build/%{bname}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
%add_to_maven_depmap org.apache.xmlgraphics %{bname} %{version} JPP %{name}

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 build/maven/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/xmlgraphics-fop

# data
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr hyph $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr conf $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc NOTICE LICENSE README known-issues.xml status.xml

%attr(0755,root,root) %{_bindir}/xmlgraphics-fop
%{_javadir}/%{name}*.jar
%{_datadir}/%{name}
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Tue May 26 2009 David Walluck <dwalluck@redhat.com> 0:0.95-6
- cleanup

* Fri Sep 12 2008 David Walluck <dwalluck@redhat.com> 0:0.95-5
- fix java-devel requires

* Sun Aug 10 2008 David Walluck <dwalluck@redhat.com> 0:0.95-4
- fix fop script

* Fri Aug 01 2008 David Walluck <dwalluck@redhat.com> 0:0.95-3
- GCJ fixes

* Fri Aug 01 2008 David Walluck <dwalluck@redhat.com> 0:0.95-2
- add new cli patch

* Thu Jul 31 2008 David Walluck <dwalluck@redhat.com> 0:0.95-1
- 0.95

* Thu Jul 31 2008 David Walluck <dwalluck@redhat.com> 0:0.94-4
- update and rebuild for xmlgraphics-batik
- patch cli to look for xmlgraphics-fop.jar in addition to fop.jar

* Thu Jul 17 2008 David Walluck <dwalluck@redhat.com> 0:0.94-4
- remove javadoc scriptlets
- GCJ fixes
- fix maven directory ownership
- update BuildRoot
- update License
- remove Vendor and Distribution

* Tue Mar 18 2008 Ralph Apel <r.apel at r-apel.de> - 0:0.94-3jpp
- Fix classpath in script 
- (B)R xerces, xalan, xml-commons-jaxp-a.3-apis

* Tue Feb 26 2008 Ralph Apel <r.apel at r-apel.de> - 0:0.94-2jpp
- Replace avalon-framework with excalibur-avalon-framework-{api,impl}

* Mon Feb 25 2008 Ralph Apel <r.apel at r-apel.de> - 0:0.94-1jpp
- Derived 0.94 from 0.20.5 keep this as "fop"
- Add pom and depmap frag
- Activate tests

* Fri May 11 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-12jpp
- Rebuild taking care of arch for src.rpm

* Thu May 10 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-11jpp
- Make Vendor, Distribution based on macro

* Thu Feb 22 2007 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-10jpp
- Add gcj_support option

* Thu Mar 30 2006 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-9jpp
- First build for JPP-1.7
- Replace avalon-framework, avalon-logkit with their new excalibur-*
  counterparts
- Drop non-free jimi and jai BRs

* Tue Oct 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-8jpp
- Patch to Batik >= 1.5.1

* Fri Oct 07 2005 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-7jpp
- Omit ant -d flag

* Mon Aug 23 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-6jpp
- Build with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-5jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:0.20.5-4jpp
- Upgrade to Ant 1.6.X

* Thu Jan  8 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-3jpp
- BuildRequires ant-optional.
- Crosslink with full J2SE javadocs instead of just JAXP/XML-commons.
- Add Main-Class back to manifest.

* Tue Sep 23 2003 Paul Nasrat <pauln at truemesh.com> - 0:0.20.5-2jpp
- Fix script and requires
- Remove class path in manifest
- New javadoc style

* Sat Jul 19 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-1jpp
- Update to 0.20.5.
- Crosslink with xml-commons-apis and batik javadocs.
- BuildRequires jai, jce and jimi.

* Sat Jun  7 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-0.rc3a.1jpp
- Update to 0.20.5rc3a.
- Include fop script.
- Non-versioned javadoc symlinks.

* Thu Apr 17 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-0.rc2.1jpp
- Update to 0.20.5rc2 and JPackage 1.5.

* Sun Mar 10 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.3-1jpp
- 0.20.3 final
- fixed missing symlink

* Mon Jan 21 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.3-0.rc.1jpp
- 0.20.3rc
- first unified release
- javadoc into javadoc package
- no dependencies for manual package
- s/jPackage/JPackage
- adaptation to new xalan-j2 package
- requires and buildrequires avalon-logkit

* Thu Aug 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.1-1mdk
- first release
